/*----------------------------------------------------------------------
* Copyright Channel Blaster Int'l
*
* http://www.ChannelBlaster.com
*
* You are free to copy and modify this code. However, please leave this
* comment in place.
*
* February 1998
----------------------------------------------------------------------*/
package FourEyes;

import java.io.*;

public class FourEyes implements Serializable 
{
  boolean enabled = true;             // Write messages?
  int destination = CONSOLE;          // Where to write them
  String filepath = "c:\\debug.txt";  // Location for file messages
  
  static final int CONSOLE = 0;       // Constants for 'destination'
  static final int FILE = 1;
  static final int BOTH = 2;
 
  //---------------------------------------------------  
  // We are required to have a no-argument constructor
  //---------------------------------------------------
  public FourEyes() 
  {
  }

  //---------------------------------------------------
  //---------------------------------------------------
  public void writeMsg(String msg) 
  {
    if (enabled) 
    {
      if (destination == CONSOLE || destination == BOTH)
        System.out.println("Debug: " + msg);
        
      if (destination == FILE || destination == BOTH) 
      {
        try 
        { // A good place for an enhancement. Opening and closing
          // for each write is quite inefficient.
          FileWriter writer = new FileWriter(filepath, true);
          writer.write("Debug: " + msg);
          writer.write(System.getProperty("line.separator"));
          writer.flush();          
          writer.close();
        }            
        catch (Exception e) 
        {
          System.out.println("File I/O error");
        }
      }        
    }  
  }    

  //---------------------------------------------------
  //---------------------------------------------------
  public void setEnabled(boolean flag) 
  {
    enabled = flag;
  }
  public boolean getEnabled() 
  {
    return enabled;
  }  
  
  //---------------------------------------------------
  //---------------------------------------------------
  public void setDestination(int dest) 
  {
    destination = dest;
  }
  public int getDestination() 
  {
    return destination;
  }
 
  //---------------------------------------------------
  //---------------------------------------------------
  public void setFilepath(String path) 
  {
    filepath = path;
  }  
  public String getFilepath() 
  {
    return filepath;
  }
}
