Attribute VB_Name = "mNewStringPerf"
'VB6 Pro Review Benchmarks
'1998 PC Magazine.  All Rights Reserved
'Written by Will Fastie

Global Const sVB5 = "VB5"
Global Const sVB6 = "VB6"
Global Const sResultFile = "Result.txt"

Global Const sVBVersion = sVB6

Global ResultFileName As String

Global Const Iterations = 100000

Global StartTime As Single
Global StopTime As Single
Global NrSecs As Single
Sub BenchFormatDate(n As Integer)
Dim s As String, ss As String
Dim i As Long, d As Date, ds As String
    Print #n, "-- Format$ vs FormatDateTime --"
    'Format$ version
    d = Date
    StartTime = Timer
    For i = 1 To Iterations
        ds = Format$(d, "Long Date")
    Next i
    StopTime = Timer
    NrSecs = StopTime - StartTime
    result = FormatResult(Iterations, NrSecs)
    Print #n, "Format$:      " & result
    'New intrinsic
    StartTime = Timer
    For i = 1 To Iterations
        ds = FormatDateTime(d, vbLongDate)
    Next i
    StopTime = Timer
    NrSecs = StopTime - StartTime
    result = FormatResult(Iterations, NrSecs)
    Print #n, "DateTime:     " & result
End Sub
Sub BenchFormatCurrency(n As Integer)
Dim s As String, ss As String
Dim i As Long
Dim m As Currency, ms As String
    Print #n, "-- Format$ vs FormatCurrency --"
    'Format$ version
    m = 23456789.01
    StartTime = Timer
    For i = 1 To Iterations
        ms = Format$(m, "Currency")
    Next i
    StopTime = Timer
    NrSecs = StopTime - StartTime
    result = FormatResult(Iterations, NrSecs)
    Print #n, "Format$:      " & result
    'New intrinsic
    StartTime = Timer
    For i = 1 To Iterations
        ms = FormatCurrency(m)
    Next i
    StopTime = Timer
    NrSecs = StopTime - StartTime
    result = FormatResult(Iterations, NrSecs)
    Print #n, "Currency:     " & result
End Sub

Sub BenchFormatPercent(n As Integer)
Dim s As String, ss As String
Dim i As Long
Dim p As Single, ps As String
    Print #n, "-- Format$ vs FormatPercent --"
    'Format$ version
    p = 0.6666
    StartTime = Timer
    For i = 1 To Iterations
        ps = Format$(p, "Percent")
    Next i
    StopTime = Timer
    NrSecs = StopTime - StartTime
    result = FormatResult(Iterations, NrSecs)
    Print #n, "Format$:      " & result
    'New intrinsic
    StartTime = Timer
    For i = 1 To Iterations
        ps = FormatPercent(p)
    Next i
    StopTime = Timer
    NrSecs = StopTime - StartTime
    result = FormatResult(Iterations, NrSecs)
    Print #n, "Percent:      " & result
End Sub
Sub BenchFormatNumber(n As Integer)
Dim s As String, ss As String
Dim i As Long
Dim nr As Double, nrs As String
    Print #n, "-- Format$ vs FormatNumber --"
    'Format$ version
    nr = 23456789.01
    StartTime = Timer
    For i = 1 To Iterations
        nrs = Format$(nr, "Standard")
    Next i
    StopTime = Timer
    NrSecs = StopTime - StartTime
    result = FormatResult(Iterations, NrSecs)
    Print #n, "Format$:      " & result
    'New intrinsic
    StartTime = Timer
    For i = 1 To Iterations
        nrs = FormatNumber(nr)
    Next i
    StopTime = Timer
    NrSecs = StopTime - StartTime
    result = FormatResult(Iterations, NrSecs)
    Print #n, "Number:       " & result
End Sub


Sub DoBenchMark(lst As ListBox)
Dim n As Integer
    Screen.MousePointer = vbHourglass
    'Initializations
    '
    'Delete the Result file
    If Dir(ResultFileName) <> "" Then Kill ResultFileName
    'Re-establish the result file
    n = FreeFile
    Open ResultFileName For Output As #n
    Print #n, sVBVersion & " Results:  " & _
              Format$(Now, "Medium Date") & " " & _
              Format$(Now, "hh:mm:ss am/pm")
    Print #n, "Iterations:   " & Format$(Iterations, "#,##0")
    'Do the Benchmarks, each of which records its own results
    BenchFormatDate n
    BenchFormatCurrency n
    BenchFormatPercent n
    BenchFormatNumber n
    '
    'Close the result file
    Close #n
    Screen.MousePointer = vbDefault
End Sub


Function FormatResult(Iterations As Long, NrSecs As Single) As String
Dim TotalSecs As Double, PerSec As Double
    PerSec = CDbl(Iterations) / NrSecs
    FormatResult = Format$(NrSecs, "#0.000") & " secs, " & _
                   Format$(PerSec, "#,##0") & " per/sec"
End Function

Sub ShowResults(lst As ListBox)
    lst.Clear
    ShowResult sVB6, lst
End Sub


Sub ShowResult(VBVer As String, lst As ListBox)
Dim f As String, x As String, n As Integer, l As String
    f = App.Path & "\" & VBVer & sResultFile
    x = Dir(f)
    If x = "" Then
        lst.AddItem VBVer & ":  No results available."
    Else
        n = FreeFile
        Open f For Input As #n
        While Not EOF(n)
            Line Input #n, l
            lst.AddItem l
        Wend
        Close #n
    End If
End Sub



