Attribute VB_Name = "mStringPerf"
'VB6 Pro Review Benchmarks
'1998 PC Magazine.  All Rights Reserved
'Written by Will Fastie

Global Const sResultFile = "Result.txt"

Global ResultFileName As String

Global Const Iterations = 10000000

Global StartTime As Single
Global StopTime As Single
Global NrSecs As Single
Global FormattedTime As String

Global Const AlphaFwd = "abcdefghijklmnopqrstuvwxyz"
Global Const AlphaRev = "zyxwvutsrqponmlkjihgfedcba"
Global NrAlpha As Long
Sub BenchMidOut(n As Integer)
Dim s As String, ss As String
Dim iteri As Long, iterj As Long, i As Long, j As Long
    iterj = 25
    iteri = Iterations / iterj
    StartTime = Timer
    s = AlphaFwd
    For i = 1 To iteri
        For j = 1 To iterj
            ss = Mid$(s, j, 1)
        Next j
    Next i
    StopTime = Timer
    NrSecs = StopTime - StartTime
    result = FormatResult(Iterations, NrSecs)
    Print #n, "Mid$ Out:     " & result
End Sub
Sub BenchLeft(n As Integer)
Dim s As String, ss As String
Dim iteri As Long, iterj As Long, i As Long, j As Long
    iterj = 25
    iteri = Iterations / iterj
    StartTime = Timer
    s = AlphaFwd
    For i = 1 To iteri
        For j = 1 To iterj
            ss = Left$(s, j)
        Next j
    Next i
    StopTime = Timer
    NrSecs = StopTime - StartTime
    result = FormatResult(Iterations, NrSecs)
    Print #n, "Left$:        " & result
End Sub
Sub BenchFormat(n As Integer)
Dim s As String, ss As String
Dim iteri As Long, iterj As Long, i As Long, j As Long
    iterj = 25
    iteri = Iterations / iterj
    StartTime = Timer
    s = AlphaFwd
    For i = 1 To iteri
        For j = 1 To iterj
            ss = Format$(Now, "Medium Date")
        Next j
    Next i
    StopTime = Timer
    NrSecs = StopTime - StartTime
    result = FormatResult(Iterations, NrSecs)
    Print #n, "Format$:      " & result
End Sub
Sub BenchRight(n As Integer)
Dim s As String, ss As String
Dim iteri As Long, iterj As Long, i As Long, j As Long
    iterj = 25
    iteri = Iterations / iterj
    StartTime = Timer
    s = AlphaFwd
    For i = 1 To iteri
        For j = 1 To iterj
            ss = Right$(s, j)
        Next j
    Next i
    StopTime = Timer
    NrSecs = StopTime - StartTime
    result = FormatResult(Iterations, NrSecs)
    Print #n, "Right$:       " & result
End Sub

Sub BenchAsc(n As Integer)
Dim s As String, ss As String, c As Integer
Dim iteri As Long, iterj As Long, i As Long, j As Long
    iterj = 25
    iteri = Iterations / iterj
    StartTime = Timer
    s = "A"
    For i = 1 To iteri
        For j = 1 To iterj
            c = Asc(s)
        Next j
    Next i
    StopTime = Timer
    NrSecs = StopTime - StartTime
    result = FormatResult(Iterations, NrSecs)
    Print #n, "Asc:          " & result
End Sub
Sub BenchChr(n As Integer)
Dim s As String, ss As String, c As Integer
Dim iteri As Long, iterj As Long, i As Long, j As Long
    iterj = 25
    iteri = Iterations / iterj
    StartTime = Timer
    c = 65
    For i = 1 To iteri
        For j = 1 To iterj
            s = Chr$(c)
        Next j
    Next i
    StopTime = Timer
    NrSecs = StopTime - StartTime
    result = FormatResult(Iterations, NrSecs)
    Print #n, "Chr$:         " & result
End Sub


Sub BenchMidIn(n As Integer)
Dim s As String, ss As String
Dim iteri As Long, iterj As Long, i As Long, j As Long
    iterj = 100
    iteri = Iterations / iterj
    StartTime = Timer
    s = Space$(iterj)
    For i = 1 To iteri
        For j = 1 To iterj
            Mid$(s, j, 1) = "x"
        Next j
    Next i
    StopTime = Timer
    NrSecs = StopTime - StartTime
    result = FormatResult(Iterations, NrSecs)
    Print #n, "Mid$ In:      " & result
End Sub

Sub BenchConCat(n As Integer)
Dim s As String, ss As String
Dim iteri As Long, iterj As Long, i As Long, j As Long
    iterj = 100
    iteri = Iterations / iterj
    StartTime = Timer
    ss = Left$(AlphaFwd, 2)
    For i = 1 To iteri
        s = ""
        For j = 1 To iterj
            s = s & ss
        Next j
    Next i
    StopTime = Timer
    NrSecs = StopTime - StartTime
    result = FormatResult(Iterations, NrSecs)
    Print #n, "ConCat (&):   " & result
End Sub

Sub DoBenchMark(lst As ListBox)
Dim n As Integer
    'Visualizations
    frmStringPerf.lstResults.Clear
    DoEvents
    Screen.MousePointer = vbHourglass
    'Initializations
    NrAlpha = Len(AlphaFwd)
    'Delete the Result file
    Kill ResultFileName
    'Re-establish the result file
    n = FreeFile
    Open ResultFileName For Output As #n
    Print #n, sVBVersion & " Results:  " & _
              Format$(Now, "Medium Date") & " " & _
              Format$(Now, "hh:mm:ss am/pm")
    Print #n, "Iterations:   " & Format$(Iterations, "#,##0")
    'Do the Benchmarks, each of which records its own results
    BenchMidOut n
    BenchMidIn n
    BenchConCat n
    BenchLeft n
    BenchRight n
    BenchAsc n
    BenchChr n
    '
    'Close the result file
    Close #n
    Screen.MousePointer = vbDefault
End Sub


Function FormatResult(Iterations As Long, NrSecs As Single) As String
Dim TotalSecs As Double, PerSec As Double
    PerSec = CDbl(Iterations) / NrSecs
    FormatResult = Format$(NrSecs, "#0.000") & " secs, " & _
                   Format$(PerSec, "#,##0") & " per/sec"
End Function

Sub ShowResults(lst As ListBox)
Dim f As String, x As String, n As Integer, l As String
    lst.Clear
    ShowResult sVB5, lst
    ShowResult sVB6, lst
End Sub


Sub ShowResult(VBVer As String, lst As ListBox)
Dim f As String, x As String, n As Integer, l As String
    f = App.Path & "\" & VBVer & sResultFile
    x = Dir(f)
    If x = "" Then
        lst.AddItem VBVer & ":  No results available."
    Else
        n = FreeFile
        Open f For Input As #n
        While Not EOF(n)
            Line Input #n, l
            lst.AddItem l
        Wend
        Close #n
    End If
    lst.AddItem "-----------------------------------"
End Sub



